#lang racket

;;;; 1. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 16.2.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované vyhodnocovaniu výrazov,
;;;; explicitným definíciam a rekurzii. Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1 
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 21.2.2016 (nedeľa) do 12:00. 

;; [Lisp]

(define ... void)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;;; Kapitola. Explicitné definície.

;;; Sekcia. Jednoduché explicitné definície.

;; Príklad. Nasledujúci komponent obsahuje definíciu funkcie, ktorá vráti
;; štvorec (druhú mocninu) daného čísla.

(define (square x) (* x x))

;; (square 5)
;; (query square 0 10)

;; Úloha. Definujte funkciu, ktorá pre dané číslo vráti jeho tretiu mocninu.

(define (cube x) ...)

;; (cube 5)
;; (query cube 0 10)

;; Úloha. Zostrojte program, ktorý pre dané dve čísla vypočíta súčet ich
;; štvorcov. 

(define (sum-of-squares x y) ...)

;; (sum-of-squares 3 4)
;; (query (lambda (y) (sum-of-squares 1 y)) 0 10)

;; Ludolfovo číslo (približne).

(define π 3.14)

;; Úloha. Zostrojte program, ktorý vypočíta obvod kruhu z jeho polomeru.

(define (circumference r) ...)

;; Úloha. Zostrojte program, ktorý vypočíta obsah kruhu z jeho polomeru.

(define (area r) ...)

;; Úloha. Zostrojte program, ktorý vypočíta povrch gule z jej polomeru.

(define (surface r) ...)

;; Úloha. Zostrojte program, ktorý vypočíta objem gule z jej polomeru.

(define (volume r) ...)

;;; Sekcia. Explicitné definície s podmienkovými výrazmi.

;; Príklad. Nasledujúci komponent obsahuje definíciu signum funkcie, ktorá
;; vráti znamienko daného reálneho čísla:
;;   (x > 0 → sgn(x) = 1) ∧ sgn(0) = 0 ∧ (x < 0 → sgn(x) = -1)

(define (sgn x)
  (cond ((> x 0) 1)
        ((= x 0) 0)
        ((< x 0) -1)))

;; Alternatívna definícia s pomocou špeciálnej formy else.

(define (sgn2 x)
  (cond ((> x 0) 1)
        ((= x 0) 0)
        (else -1)))

;; Alternatívna definícia s pomocou špeciálnej formy if.

(define (sgn3 x)
  (if (> x 0)
      1
      (if (= x 0)
          0
          -1)))

;; Úloha. Definujte funkciu abs, ktorej výsledkom pre dané reálne číslo je jeho
;; absolútna hodnota:
;;   (x > 0 → abs(x) = x) ∧ abs(0) = 0 ∧ (x < 0 → abs(x) = -x)

(define (abs x) ...)

;; Úloha. Definujte binárnu funkciu min, ktorá pre dané dve čísla vráti ich
;; minimum:
;;   min(x,y) ≤ x ∧ min(x,y) ≤ y ∧ (min(x,y) = x ∨ min(x,y) = y)

(define (min x y) ...)

;; Úloha. Definujte binárnu funkciu max, ktorej výsledkom pre dané dve čísla je
;; ich maximum:
;;   max(x,y) ≥ x ∧ max(x,y) ≥ y ∧ (max(x,y) = x ∨ max(x,y) = y)

(define (max x y) ...)

;; (1 bod)
;; Úloha. Definujte ternárnu funkciu median, ktorá pre dané tri čísla vráti ich
;; medián:
;;   x ≤ y ∧ y ≤ z → median(x,y,z) = y
;;   median(x,y,z) = median(y,x,z) ∧ median(x,y,z) = median(x,z,y)

(define (median x y z) ...)
