#lang racket

;;;; 1. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 16.2.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované vyhodnocovaniu výrazov,
;;;; explicitným definíciam a rekurzii. Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3 
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 1
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 21.2.2016 (nedeľa) do 12:00.

;; [Lisp]

(define ... void)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;;; Kapitola. Rekurzívne definície.

;;; Sekcia. Primitívna rekurzia.

;; Príklad. Nasledujúci komponent obsahuje definíciu sumačnej funkcie pomocou
;; primitívnej rekurzie:
;;   sum(0) = 0
;;   sum(n+1) = sum(n)+n+1

(define (sum n)
  (if (= n 0)
      0
      (+ (sum (- n 1)) n)))

;; (query sum 0 10)

;; (1 bod)
;; Úloha. Definujte primitívnou rekurziou funkciu faktoriál:
;;   fact(0) = 1
;;   fact(n+1) = (n+1)×fact(n)

(define (fact n) ...)

;; (query fact 0 10)

;; Úloha. Definujte primitívnou rekurziou operáciu umocnenia exp(a,n) ≡ a^n:
;;   exp(a,0) = 1
;;   exp(a,n+1) = a×exp(a,n)

(define (exp a n) ...)

;; (query (lambda (n) (exp 2 n)) 0 10)

;; (prémia 1 bod)
;; Úloha. Definujte primitívnou rekurziou funkciu sqrt, ktorej výsledkom pre
;; dané prirodzené číslo je jeho celočíselná druhá odmocnina:
;;   sqrt(x) = y ↔ y^2 ≤ x < (y+1)^2

(define (sqrt x) ...)

;; (query sqrt 0 10)

;;; Sekcia. Obyčajná rekurzia.

;; Úloha. Nájdite rekurzívnu definíciu funkcie, ktorá enumeruje Fibonacciho
;; postupnosť:
;;   fib(0) = 0
;;   fib(1) = 1
;;   fib(n+2) = fib(n+1)+fib(n)

(define (fib n) ...)

;; (query fib 0 10)

;; (1 bod)
;; Úloha. Implementujte Euklidov algoritmus pre výpočet najväčšieho spoločného
;; deliteľa dvoch prirodzených čísel. Idea algoritmu je vyjadrená touto
;; vlastnosťou
;;   x ≠ 0 ∧ d | x → d | y ↔ d | y mod x

(define (gcd x y) ...)

;; (query (lambda (y) (gcd 6 y)) 1 20)

;;; Sekcia. Rekurzia s mierou.

;; Úloha. Implementujte Euklidov algoritmus pre výpočet najväčšieho spoločného
;; deliteľa dvoch nenulových prirodzených čísel. Idea algoritmu je vyjadrená
;; touto vlastnosťou
;;   x < y ∧ d | x → d | y ↔ d | y-x

(define (gcd2 x y) ...)

;; query (lambda (y) (gcd2 6 y)) 1 20)

;;; Sekcia. Transfinitná rekurzia.

;; (1 bod)
;; Úloha. Definujte Ackermann-Péterovej funkciu:
;;   A(0,y) = y+1
;;   A(x+1,0) = A(x,1)
;;   A(x+1,y+1) = A(x,A(x+1,y))
;; Platí:
;;   A(1,y) = y+2
;;   A(2,y) = 2*y+3 = 2*(y+3)-3
;;   A(3,y) = 8*2^y-3 = 2^(y+3)-3
;;   A(4,y) = 2^2^...^2-3

(define (A x y) ...)

;; (query (lambda (y) (A 0 y)) 0 10)
;; (query (lambda (y) (A 1 y)) 0 10)
;; (query (lambda (y) (A 2 y)) 0 10)
;; (query (lambda (y) (A 3 y)) 0 10)
;; (query (lambda (y) (A 4 y)) 0 1)
